import yzQuestion from './yzQuestion';
import $ from './jquery-vendor';
import './jquery-ui.js';

var yzDom = function(cfg) {
  this.rectNo = cfg.rectNo;
  this.questions = cfg.questions;
  this.height = cfg.height;
  this.minHeight = cfg.minHeight >= 0 ? cfg.minHeight: cfg.height;
  this.border = parseInt(cfg.border);
  this.cdelete = cfg.cdelete;
  this.isDrag = cfg.isDrag;
  this.rowDetail = cfg.rowDetail;
  this.isSubject = cfg.isSubject;
  this.content = cfg.content || null;
  this.questionsDom = [];

 // 该dom第几个question 
  this.questionIndex = 0;
  
  this.vDom = null;
  this.colDoms = {};
  // dom相关属性
  this.domId = ('lsiten_border_'+Math.random()).replace('.','_');
  this._initQustionsDoms();
}

yzDom.prototype._initQustionsDoms = function () {
  let questions = this.questions;
  for (let index in questions) {
    this.questionIndex++;

    questions[index].order = this.questionIndex;
    this.questionsDom.push(new yzQuestion(questions[index]));
  }
}

/** 
 * function 渲染客观题的dom
*/
yzDom.prototype._renderObjectiveDom = function () {
  let main = $('<div class="border-main"></div>');
  let rows = this.rowDetail;
  let cols = rows > 1 ? 3 : rows[0].index;
  let width = (100/cols) + '%';

  let index = 1;
  for (let i in rows) {
    let row = $('<div id="border-middile-box-row-'+i+'" class="border-middile-box-row"></div>');
    let height = rows[i].minHeight * parseInt(rows[i].maxnum);
    
    for (let j=0; j < cols; j++) {
      let col = $('<div class="border-middile-box-col"></div>');
      let cssOptions = {
        height: height,
        width: width
      };
      ((j % 3) < 2) && (cssOptions.borderRight = '1px solid #bfbfbf');
      col.css(cssOptions);
      this.colDoms[index++] =col;
      row.append(col);
    }
    main.append(row);
  }

  let questions = this.questionsDom;
  // question 渲染
  for (let index in questions) {
    questions[index].renderToDom();
    this.colDoms[questions[index].blockindex].append(questions[index].vdom);
  }
  this.vDom.append(main);
};

/**
 * function 渲染普通的题的dom
 */
yzDom.prototype._renderCommonDom = function () {
  let main = $('<div class="border-main"></div>');
  let questions = this.questionsDom;
  // question 渲染
  for (let index in questions) {
    questions[index].renderToDom();
    main.append(questions[index].vdom);
  }
  // main.css(cssOption);
  this.vDom.append(main);
};


/** 
 * function 将数据转换为vdom的形式
*/
yzDom.prototype.renderToDom = function () {
  this.vDom = $('<div id="' +this.domId+ '" class="border-selection"></div>');
 
  !this.isSubject ? this._renderObjectiveDom() : this._renderCommonDom();

  let cssOption = {height: this.height};
  this.border === 1 && (cssOption.border = '1px solid #bfbfbf');
  this.vDom.css(cssOption)

  //监听事件
  this._addLsiteners();
}


/** 
 * function 监听resizing事件
*/
yzDom.prototype._addLsiteners = function () {
  let _this = this;
  if (this.isSubject && this.isDrag) {
    $(this.vDom).resizable({
      minWidth: '100%',
      maxWidth: '100%',
      minHeight: 0,
      disabled: false,
      grid:10,
      helper: "ui-resizable-helper",
      resize: function(event, ui) {
      },
      stop: function(event, ui) {
        var nowH = event.target.clientHeight;
        if (_this.cdelete) {
          _this.height =nowH < _this.minHeight ? 0 : nowH;
        } else {
          _this.height =nowH < _this.minHeight ? _this.minHeight : nowH;
        }
        $(_this.vDom).trigger('refreshPage');
      }
    });
  }
};
export default yzDom;