import yzDom from './yzDom';
import $ from 'jquery';

let yzPage = function (cfg) {
  this.hasHeader = cfg.hasHeader || false;
  this.header = cfg.header || {};
  this.gap = cfg.maxHeight || 700;
  this.index = 0;
  this.doms = [];
  // 如果有头部信息去除头部高度
  this.hasHeader && (this.gap -= this.header.height);

  this.vDom = null;
  // dom相关属性
  this.domId = ('lsiten_page_'+Math.random()).replace('.','_');
  this.domHeight = cfg.maxHeight || 700;
};

yzPage.prototype.addDom = function (item) {
  this.index++;
  this.doms.push(new yzDom(item));
  this.gap -= item.height;
  
};

/** 
 * @TODO 补充成组件
*/
yzPage.prototype._renderHeaderDom = function () {
  let header = $('<div id="' +this.domId+ '_header" class="page-selection-header"></div>');
  let main = $('<div class="header-main"></div>');
  header.css({
    height: this.header.height + 'px'    
  });
  header.append(main);
  return header;
};

yzPage.prototype._renderBodyDom = function () {
  let body = $('<div id="' +this.domId+ '_body" class="page-selection-body"></div>');
  let doms = this.doms;
  for (let index in doms) {
    doms[index].renderToDom();
    body.append(doms[index].vDom)
  }
  return body;
};
/** 
 * function 将数据转换为vdom的形式
*/
yzPage.prototype.renderToDom = function () {
  this.vDom = $('<div id="' +this.domId+ '" class="page-selection"></div>');
  this.hasHeader && this.vDom.append(this._renderHeaderDom());
  this.vDom.append(this._renderBodyDom());
  this.vDom.css({
    height: this.domHeight + 'px'
  });

};
export default yzPage;